# Copyright 2018, 2019 Bruce Cowan <bruce@bcowan.me.uk>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import re

from errbot import BotPlugin


class XKCD(BotPlugin):
    """XKCD word substitutions."""

    def activate(self):
        super().activate()

        self._replacements = [
            (re.compile(r'\ballegedly\b', re.IGNORECASE), "kinda probably"),
            (re.compile(r'\bcar\b', re.IGNORECASE), "cat"),
            (re.compile(r'\bcloud\b', re.IGNORECASE), "butt"),
            (re.compile(r'\belection\b', re.IGNORECASE), "eating contest"),
            (re.compile(r'\bforce\b', re.IGNORECASE), "horse"),
            (re.compile(r'\bkeyboard\b', re.IGNORECASE), "leopard"),
            (re.compile(r'\bspace\b', re.IGNORECASE), "spaaaaaace")]

    def callback_message(self, message):
        ret = message.body

        for replacement in self._replacements:
            ret = re.sub(replacement[0], replacement[1], ret)

        if message.body is not ret:
            self.send(message.to, "Did you mean: " + ret, message, True)
